package com.sample.test;


import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

import org.jbpm.test.JbpmJUnitBaseTestCase;
import org.junit.Test;
import org.kie.api.runtime.KieSession;
import org.kie.api.runtime.manager.RuntimeEngine;
import org.kie.api.runtime.manager.RuntimeManager;
import org.kie.api.runtime.process.ProcessInstance;

import bitronix.tm.TransactionManagerServices;
import bitronix.tm.resource.jdbc.PoolingDataSource;

/**
 * This is a sample file to launch a process.
 */
public class PersistenceTest extends JbpmJUnitBaseTestCase {

	@Test
	public void testPersistence() {
		RuntimeManager manager = createRuntimeManager("sample.bpmn");
		RuntimeEngine engine = getRuntimeEngine(null);
		KieSession ksession = engine.getKieSession();
		 
		ProcessInstance processInstance = ksession.startProcess("com.sample.bpmn.hello");

		//assertProcessInstanceActive(processInstance.getId(), ksession);
		
//		 org.kie.api.runtime.Environment env = org.drools.core.impl.EnvironmentFactory.newEnvironment();
//	     EntityManagerFactory emf = Persistence.createEntityManagerFactory("org.jbpm.persistence.jpa");
//	     env.set(org.kie.api.runtime.EnvironmentName.ENTITY_MANAGER_FACTORY, emf);
//	     env.set(org.kie.api.runtime.EnvironmentName.TRANSACTION_MANAGER, TransactionManagerServices.getTransactionManager());
//		
	
	     //Creating the sample StudentInfo

	   /*  StudentInfoDto sidto = new StudentInfoDto();
	     sidto.setStudentId("22");sidto.setStudent_name("TestPersistence");sidto.setOwner("PeristenceOwner");*/
	     
	    
		assertProcessInstanceCompleted(processInstance.getId(), ksession);
		
		manager.disposeRuntimeEngine(engine);
		manager.close();
	}
	
	@Override
	protected PoolingDataSource setupPoolingDataSource() {
		PoolingDataSource pds = new PoolingDataSource();
  	  	pds.setUniqueName("jdbc/jbpm-ds1");
        pds.setClassName("bitronix.tm.resource.jdbc.lrc.LrcXADataSource");
        pds.setMaxPoolSize(50);
        pds.setAllowLocalTransactions(true);
        pds.getDriverProperties().put("user", "jbpm6");
        pds.getDriverProperties().put("password", "jbpm6");
        pds.getDriverProperties().put("url", "jdbc:mysql://localhost:3306/jbpm6");
        pds.getDriverProperties().put("driverClassName", "com.mysql.jdbc.Driver");
        pds.init();
        return pds;
	}
	
	public PersistenceTest() {
		super(true, true);
	}

}